// Abtest1.prg
//
// Test routine to exercise simulated array browse class

#include "Abrowser.ch"
#include "Directry.ch"
#include "InKey.ch"

// Default column separator
#define DEF_CSEP  " " + chr(179) + " "

// Default heading separator
#define DEF_HSEP chr(205) + chr(209) + chr(205)

// Default footing separator
#define DEF_FSEP chr(205) + chr(207) + chr(205)


FUNCTION Abtest1

LOCAL oTbr   := ABrowseNew()
LOCAL aFiles := Directory("*.dbf")
LOCAL lExitRequested := .F.
LOCAL nKey
LOCAL oTbc
LOCAL i

  IF Len(aFiles) < 1
    Alert("No matching files")
    QUIT
  ENDIF

  oTbr:arrayReference := aFiles
  oTbr:colSep  := DEF_CSEP
  oTbr:headSep := DEF_HSEP
  oTbr:footSep := DEF_FSEP

  oTbr:nTop    := 1
  oTbr:nLeft   := 1
  oTbr:nBottom := MaxRow() - 1
  oTbr:nRight  := 29

  CLEAR SCREEN
  @ 0, 0 TO MaxRow(), 30

  oTbc := TBColumnNew("File Name", ;
                      {|| oTbr:arrayReference[oTbr:arrayIndex, F_NAME] })
  oTbc:width := 12
  oTbr:addColumn(oTbc)

  oTbc := TBColumnNew("File Size", ;
                      {|| oTbr:arrayReference[oTbr:arrayIndex, F_SIZE] })
  oTbr:addColumn(oTbc)

  oTbc := TBColumnNew("File Date", ;
                      {|| oTbr:arrayReference[oTbr:arrayIndex, F_DATE] })
  oTbr:addColumn(oTbc)

  oTbc := TBColumnNew("File Time", ;
                      {|| oTbr:arrayReference[oTbr:arrayIndex, F_TIME] })
  oTbr:addColumn(oTbc)

  ? seconds()
  FOR i := 1 To 1000
    StdMeth(oTbr, K_UP)
  NEXT
  ? Seconds()
  QUIT

  DO WHILE !lExitRequested
    DO WHILE !oTbr:stabilize()
    ENDDO
    nKey := InKey(0)
    IF !StdMeth(oTbr, nKey)
      // Handle exceptions
      DO CASE
        CASE nKey == K_ESC
          lExitRequested := .T.
      ENDCASE
    ENDIF

  ENDDO

RETURN NIL
